-- FrontLoaderDisplay
--
-- Version 1.0
-- Autor Ralf08
-- 
-- Change log:
-- 10.12.2016 / Ralf08 / first release



--local FirstRun
FLD = {};


local FLD_directory = g_currentModDirectory;
local HoT = 0
local ang = 0



function FLD.prerequisitesPresent(specializations)
	return true
end;

function FLD:load()
	self.FLD = {}
	self.FLD.show = false
	self.FLD.corA = 0
	self.FLD.corH = 0
	self.FLD.curRot = 0
	
	for _,joint in pairs(self.inputAttacherJoints) do
		if joint.jointType == 4 or joint.jointType == 5 or joint.jointType == 9 or joint.jointType == 13 then
			self.FLD.enable = true
			self.FLD.tool = false
			if SpecializationUtil.hasSpecialization(Shovel, self.specializations) then
				--print("FLD SHOVEL")
				if self.movingTools ~= nil and self.fillUnits ~= nil then
					--print("FLD MT & FU")
					if table.getn(self.movingTools)	> 0 and table.getn(self.fillUnits) > 0 then
						--print("FLD MT>0 FU>0")
						if self.movingTools[1].rotMin ~= nil then
							--print("FLD ROTMIN")
							if getXMLString(self.xmlFile, "vehicle.fillUnits.fillUnit(0)#fillTypeCategories") == "bulk windrow" then
								--print("FLD BULK WINDROW")
								self.FLD.tool = true
							--else
								--print(getXMLString(self.xmlFile, "vehicle.fillUnits.fillUnit(0)#fillTypeCategories"))
							end;
						end;
					end;
				end;
			end;
		else
			self.FLD.enable = false
		end;
	end;
end;

function FLD:delete()
end;

function FLD:mouseEvent(posX, posY, isDown, isUp, button)
end;

function FLD:keyEvent(unicode, sym, modifier, isDown)
end;

function FLD:update(dt)
	if self.FLD.enable and self:getIsActiveForInput() then
		if self.components ~= nil then
			local x,y,z = localToLocal(self.components[1].node,self.FLD.parentVehicle.components[1].node, 0, 0, 0)
			local xD,yD,zD = worldDirectionToLocal(self.components[1].node, localDirectionToWorld(self.FLD.parentVehicle.components[1].node, 0, 0, 1))
			if self.FLD.tool then
				self.FLD.curRot = self.movingTools[1].curRot[1] - self.movingTools[1].rotMin
			end;
			
			HoT = math.floor((y + self.FLD.corH)*100+0.5)/100
			ang = math.floor(math.deg(math.atan2(-yD,zD) - self.FLD.curRot) + 0.5) + self.FLD.corA
			
		end;
		
		self.FLD.show = true
		
		if InputBinding.hasEvent(InputBinding.FLD_SET) then
			if self.FLD.corA == 0 and self.FLD.corH == 0 then
				self.FLD.corA = self.FLD.corA - ang
				self.FLD.corH = self.FLD.corH - HoT
			else
				self.FLD.corA = 0
				self.FLD.corH = 0
			end;
		end;
	end;
end;

function FLD:onAttach()
	local parentVehicle = self
	while parentVehicle.attacherVehicle do
		parentVehicle = parentVehicle.attacherVehicle
	end;
	self.FLD.parentVehicle = parentVehicle
end;

function FLD:onDetach(attacherVehicle)
	self.FLD.corA = 0
	self.FLD.corH = 0
	self.FLD.parentVehicle = nil
end;

function FLD:updateTick(dt)
end;

function FLD:readStream(streamId, connection)
end;

function FLD:writeStream(streamId, connection)
end;

function FLD:onEnter()
end;

function FLD:onLeave()
	self.FLD.show = false
end;

function FLD:draw()
	if self.FLD.show then
		g_currentMission:addHelpButtonText(g_i18n:getText("input_FLD_SET"), InputBinding.FLD_SET);
		
		setTextAlignment(RenderText.ALIGN_CENTER);
		renderText(0.5,0.01,g_currentMission.speedTextSize, string.format("%.2f", HoT) .." Meter / " .. ang .." Grad");
	end;
end;
